# Introduction to pyFuujinroluDestiny

## 系统名词简介

### 自机

玩家直接操纵的角色、人物、飞机等称为自机。

### 子机

也称为`option`等，指漂浮在自机周围，能与自机进行同步攻击的物体。

子机的数量随游戏和机体而变化，部分机体的子机可以离开自机。

### 射击

发射攻击，击毁敌机。触发键为 `[Z]` 键。

#### 控枪

指控制按住与松开 `[Z]` 键，使自机适当停止射击（也称停火、停枪等）的动作。

`[Z]` 键在选择支中还用于选中当前选项。

在需要控制击破时机、避免击破某些敌人（例如死尸弹）的时候使用。

### 灵力

也称为`power`、`P`等。表示自机的火力大小。火力达到最大值的状态称为`满P`，本作中为`5.00`。满灵力后收集`P`点可以获得分数奖励。

### 霊撃

也称炸弹、B、雷、保险等，使用后短时间内自机无敌，并且附带消弹、自动收集效果。

每次使用灵力会降低`1.00`，灵力低于`1.00`时无法使用。

由 `[X]` 键触发。

### 灵体

自机状态，此时自机没有判定，且左右可穿透屏幕。

### Miss

也称为`被弹`，指自机判定点接触到敌人子弹的判定区域或者有判定的敌人，并且没有发动`被弹Bomb`或者其他自保手段。

此时会损失一个残机、放出一定数量的道具、损失大量灵力。

被弹后会进行全屏消弹，但不会自动收集。一段时间内自机处于灵体状态。

俗称“撞了”、“biu（模仿音效声）”等。

#### 残机

也称为`player`、`life`、`命`、`残`等，指玩家剩余的容许`Miss`的次数，会显示在屏幕右侧。

默认初始值为`4`（游戏开始时右上角三颗星）。

获得`1up`道具、分数超过`5e5`分的整数倍可以增加残机。


### 判定

指自机、子弹、敌人的实际攻击或被击区域的大小。子弹的判定通常小于其视觉大小。

#### 判定点

低速模式下自机身上显示的圆点，标明自机的实际判定大小。

只有子弹的判定区与其重合时才算自机中弹，虽然称为判定“点”，不过还是有一定大小的(**注意:未显示判定点时判定点仍然存在**)。

#### 体术

能通过撞击使自机`Miss`的敌人称为具有体术判定。而被这样的敌人撞死则称为被体术。

#### 擦弹

当自机判定点与子弹距离小于擦弹阈值但不构成Miss时，判定为擦弹，会播放音效、增加分数，也会在右边栏中显示。

#### 微移

微移是指射击游戏中被使用的一种主要的基本技巧。

一种微微移动自机来躲过敌人的弹幕的技巧。虽然多是玩家会自然而然掌握的技巧，要点是有意识的去躲过的话效果会更好。对于自机狙和高效率地回避奇数弹有很大的效果，也能防止“无谓的动作导致的失误中弹”“被逼到画面角落”之类的情况发生。

比起一直去注意，作为一种对特定的敌人的攻击而采用的技巧来认识比较好吧。太在意这个而移动的太少的话，也可能陷入自机周围都是弹幕的危机之中。

### 道具

击破敌机会出现的奖励，可以提高火力、分数等，为了和弹幕区别开来，被设计成矩形。

#### 火力道具

可以增加火力的道具，有`大P点`，`小P点`。

#### 得点道具

俗称蓝点，增加分数的最主要手段之一。

#### 奖励道具

击破某些敌机和boss战中某些阶段之后，出现的直接奖励残机或者雷的道具，以及残机和雷的碎片道具等。

### 回收线
当自机的判定点超过某个高度（游戏区从上往下`100像素`）后，屏幕内的所有道具将会自动飞到自机所在位置并回收，这个高度所在的位置被称为（道具）回收线。道具的回收对混关和打分都很重要。

#### 上线

也称上线收点，指自机向上走超过回收线并回收道具的动作。

最基本的回收道具方式。

### 被弹Bomb

中弹后到判定掉残之前有几帧的间隔（详见代码），在这个时间内使用`Bomb`，则玩家不会损失残机，而是会放出一个`Bomb`。

通常都之称为`决死`、`决死B`等。

对于一般通关来说，指望这种方式救场是一种非常危险的行为。

### 面

也称为（第几）关、关卡、Stage等。

本作仅用于演示，只有一面。

### 道中

一关中，除了最后的BOSS（关底BOSS）之外的部分。通常包括`前半道中`——`道中boss`——`后半道中`。杂鱼的出现顺序往往是固定的。

### 杂鱼

没有血条的敌人，有毛玉、妖精、蝴蝶、使魔、怨灵、石头、鸟、魔法书等。通常比较脆弱。

### Boss

分为`道中boss`和`关底boss`，从boss入场开始就算作进入`boss战`。

通常会有血条，并且还会显示有几个残机。

本作仅有一个关底boss。

### 非符

也被称为通常弹幕，意为“不是符卡的部分”。boss战中一般在符卡之前出现。

### Legend List

线上排名系统前1000名进入`Legend List`，可以被维护排名。`Legend List`前20名可以在`title`页被展示。

## 弹幕相关词汇

某种弹幕出现时，通常使用以下几种词汇共同描述。

### 随机弹

顾名思义。

### 固定弹

顾名思义。

### 自机狙

也简称狙，狭义上仅仅指弹幕的瞄准及运动方向指向自机位置的弹幕；广义上指弹幕的生成位置、瞄准方向或运动方向和自机的位置有关的弹幕（也称为自机依存型弹幕、自机相关等）。

### 散狙、偏狙、泛狙、不精确狙

都是一个意思，指运动方向并不是严格指向自机的位置，而是在发射方向上具有一定的偏移的弹幕。

这种自机狙需要在移动的同时躲避随机弹，不移动的话自机必然处于弹幕最密集的位置。

### 依存

指根据boss或自机的位置等条件，决定弹幕的生成轨迹、运动方向等的弹幕。通常与上面三种弹幕类型配合来描述。

### 其他弹幕类型

这一部分弹幕类型均为形容及描述用法，并没有严格标准，实际解法一般需要配合以上四种弹型。

#### 弹链（ワインダー）

连续发射出弹与弹间隔较小的弹幕、或者以此形成墙壁状的封位弹幕。

也有设计成需要穿过弹链的弹幕，此时的弹链间隔会略宽一点。

#### 开花弹

全方位展开型的弹幕，通常在每个方向上都是相同的弹型。

## 上级词汇简介

### 延迟

从玩家输入指令到游戏做出响应之间的时间间隔，延迟产生的方式很多，比如游戏自身的延迟，因为其他软件带来的延迟，硬件带来的延迟等。

### 底力

底力指躲避子弹的能力，也即是俗称的“气合避”（気合避け），指基本凭借反应和熟练度来躲避某种有一定规律但又较为考验反应并且受到一定随机因素影响的弹幕，也就统称为避弹能力或者避弹。

### 定位

在短时间内，精确的站到某个位置上的能力，定位的难度与给定的时间和精确的程度有关，在打分中经常会要求1秒内进行像素级别的精确站位。

### 规划

规划指的是玩家从视频，录像，前人经验等得到的讯息，结合自己的游戏经验，对游戏流程做一定程度的计划，例如什么时候该使用bomb略过难点等。通常来说，越高难度的目标，所需要的规划就越详细。

### 背版

将游戏中可以固定的因素，例如敌人出现位置，敌人发弹方式，子弹躲避方式等因素（统称为版面）记忆下来，并给出对应处理方法的行为称为背版。这种做法的准确程度称为背版的精度。

### 走位

背版的一部分，将某个特定弹幕的解法或者一段道中的处理方式，通过某个固定的移动路线来完成，这种方式可以称为走位。

### 模式化

将实战中可能发生的多种情况归纳，总结出某种或者某几种固定的处理方式，这样的做法称为模式化，是极其重要的处理随机的方式。

### 安定

安定有两种含义，第一种是游戏内部存在的特殊位置（如弹源，边角，某些标志点），只要在常规弹幕形成前移动至这个点就能站着不动回避所有的弹幕，这种类型称为安定点。

第二种是一些是指某些特殊的躲避方法（如上避，侧避，内避等），可以大幅度降低难度，这种类型称为安定打法。

需要注意的是，有些安定点仅仅是理论上的安定，对于实际攻关来说，难度甚至更高于常规躲避。

### 诱导

作动词，指在一定程度上控制敌人，使其向某处移动。

作形容词，表示向着某个目标方向移动。

### 尻击

一方面指自机站到boss上方（通常与boss紧贴）并攻击boss的行为。通常目的是减少避弹或者提高自机输出。

另一方面指被背后来弹击中。

### 爆分

分数达到显示上限，不再增加。

## Referance

[thbwiki](https://thwiki.cc/)